package cn.com.ctop.oa.modules.service.impl;

import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.oa.modules.constant.QYWxConstant;
import cn.com.ctop.oa.modules.entity.WechatCheckinData;
import cn.com.ctop.oa.modules.entity.WechatUserList;
import cn.com.ctop.oa.modules.mapper.WechatCheckinDataMapper;
import cn.com.ctop.oa.modules.service.IWechatCheckinDataService;
import cn.com.ctop.oa.modules.service.IWechatTokenService;
import cn.com.ctop.oa.modules.service.IWechatUserListService;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * 企业微信用户
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-09-15
 */
@Service
@Slf4j
public class WechatCheckinDataServiceImpl extends ServiceImpl<WechatCheckinDataMapper, WechatCheckinData> implements IWechatCheckinDataService {
    @Autowired
    private IWechatTokenService tokenService;
    @Autowired
    private IWechatUserListService userListService;

    @Override
    public void getCheckinData() {
        try {
            Map<String, Object> qywxAccessToken = tokenService.getOAAccessToken();
            System.err.println(qywxAccessToken);
            if ((Integer) qywxAccessToken.get("code") != 0) {
                log.error("企业微信获取token失败,返回信息：{}", qywxAccessToken.get("message"));
                throw new Exception("企业微信获取token失败");
            }

            List<WechatUserList> list = userListService.list();
            if (Check.isNull(list)) {
                return;
            }


            //  params.put("access_token", (String) qywxAccessToken.get("accessToken"));
            for (WechatUserList userList : list) {
                // params.remove("useridlist");
                JSONObject params = new JSONObject();

                String userId = userList.getUserId();
                String departId = userList.getDepartId();
                params.put("opencheckindatatype", 3);

                JSONArray userArr = new JSONArray();

                userArr.add(userId);
                params.put("useridlist", userArr);
                params.put("starttime", 1598889600);
                params.put("endtime", 1600099200);


                String resultStr = HttpUtils.httpPostRequestTest(QYWxConstant.QYWX_CHECKIN_DATA + "?access_token=" + qywxAccessToken.get("accessToken"), params.toJSONString(), null);
                JSONObject resultJson = JSONObject.parseObject(resultStr);
                System.err.println(resultJson);
                Integer errcode = resultJson.getInteger("errcode");
                if (errcode == 0) {
                    JSONArray checkindata = resultJson.getJSONArray("checkindata");
                    if (!Check.isNull(checkindata)) {
                        for (int i = 0; i < checkindata.size(); i++) {
                            JSONObject jsonObject = checkindata.getJSONObject(i);
                            if (!Check.isNull(jsonObject)) {
                                WechatCheckinData checkinData = new WechatCheckinData();
                                checkinData.setDepartId(departId);
                                checkinData.setUserId(userId);
                                java.util.Date checkDate = DateUtils.stampToTime(jsonObject.getLong("checkin_time"));
                                checkinData.setCheckinTime(checkDate);
                                checkinData.setWifiname(jsonObject.getString("wifiname"));
                                checkinData.setNotes(jsonObject.getString("notes"));
                                checkinData.setLat(jsonObject.getString("lng"));
                                checkinData.setLocationDetail(jsonObject.getString("location_detail"));
                                checkinData.setGroupName(jsonObject.getString("groupname"));
                                checkinData.setDeviceid(jsonObject.getString("deviceid"));
                                checkinData.setCheckinType(jsonObject.getString("checkin_type"));
                                checkinData.setExceptionType(jsonObject.getString("exception_type"));
                                checkinData.setLocationTitle(jsonObject.getString("location_title"));
                                checkinData.setWifimac(jsonObject.getString("wifimac"));
                                checkinData.setMediaids(jsonObject.getJSONArray("mediaids").toJSONString());
                                checkinData.setLat(jsonObject.getString("lat"));
                                this.save(checkinData);

                            }
                        }

                    }


                } else {
                    //     throw new Exception("企业微信获取部门列表");

                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }


    }


}
